unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, kbmMemTable,Unit2, ExtCtrls, DBCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    kbmMemTable1: TkbmMemTable;
    kbmMemTable1Field1: TIntegerField;
    kbmMemTable1Field2: TIntegerField;
    DBGrid1: TDBGrid;
    Button1: TButton;
    DBNavigator1: TDBNavigator;
    kbmMemTable1Calc: TIntegerField;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure kbmMemTable1CalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    SecondThread:TFormThread;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
   i:integer;
begin
     // Generate thread.
     SecondThread:=TFormThread.Create(true);
     SecondThread.Resume;

     // Open table.
     kbmMemTable1.Open;

     // Generate data.
     kbmMemTable1.AttachedAutoRefresh:=false;
     for i:=0 to 100 do
     begin
          Application.ProcessMessages;
          kbmMemTable1.Append;
          kbmMemTable1.FieldByName('Field1').asinteger:=i;
          kbmMemTable1.FieldByName('Field2').asinteger:=i*2;
          kbmMemTable1.Post;
     end;
     kbmMemTable1.AttachedAutoRefresh:=true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     SecondThread.Terminate;
     SecondThread.WaitFor;
     SecondThread.Free;
end;

procedure TForm1.kbmMemTable1CalcFields(DataSet: TDataSet);
begin
     with kbmMemTable1 do
          FieldByName('Calc').asinteger:=FieldByName('Field1').asinteger*2+1;
end;

end.
