unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Db, kbmMemTable, ExtCtrls, DBCtrls;

type
  TForm2 = class(TForm)
    DataSource1: TDataSource;
    ThreadTable: TkbmMemTable;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    ThreadTableField1: TIntegerField;
    ThreadTableField2: TIntegerField;
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ThreadTableCalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TFormThread = class(TThread)
  private
        FForm:TForm2;
  public
        constructor Create(CreateSuspended: Boolean);
        destructor Destroy; override;
        procedure Execute; override;
  end;

var
  Form2: TForm2;

implementation

uses Unit1;

{$R *.DFM}

constructor TFormThread.Create(CreateSuspended: Boolean);
begin
     inherited;
     FForm:=TForm2.Create(nil);
     FForm.ThreadTable.Open;
     FForm.Show;
     FreeOnTerminate:=false;
end;

destructor TFormThread.Destroy;
begin
     FForm.ThreadTable.Close;
     FForm.hide;
     FForm.free;
     FForm:=nil;
     inherited;
end;

procedure TFormThread.Execute;
var
   i:integer;
begin
     with FForm do
     begin
          for i:=0 to 100 do
          begin
               ThreadTable.Append;
               ThreadTable.FieldByName('Field1').asinteger:=-i;
               ThreadTable.FieldByName('FIeld2').asinteger:=-i*2;
               ThreadTable.Post;
          end;
     end;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
     ThreadTable.close;
end;

procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     CanClose:=false;
end;

procedure TForm2.ThreadTableCalcFields(DataSet: TDataSet);
begin
     with ThreadTable do
          FieldByName('Calc').asinteger:=FieldByName('Field1').asinteger*2+1;
end;

end.
